## oxide-qt 1.21.5

=== CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

if(EXISTS ${CMAKE_BINARY_DIR}/CMakeLists.txt)
  message(FATAL_ERROR
          "In-source-tree builds are unsupported. You must use a separate build "
          "directory to build Oxide. Note that you will need to remove the "
          "CMakeCache.txt file from the root of your source tree before continuing")
endif()

cmake_minimum_required(VERSION 2.8.11)
project(OXIDE)

if(ENABLE_TESTS)
  enable_testing()
endif()

add_subdirectory(oxide)

=== native_client/SConstruct ===
#! -*- python -*-
# Copyright (c) 2012 The Native Client Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

import atexit
import json
import os
import platform
import re
import subprocess
import sys
import zlib
sys.path.append("./common")
sys.path.append('../third_party')

from SCons.Errors import UserError
from SCons.Script import GetBuildFailures

import SCons.Warnings
import SCons.Util

SCons.Warnings.warningAsException()

sys.path.append("tools")
import command_tester
import test_lib

import pynacl.platform

# turning garbage collection off reduces startup time by 10%
import gc
gc.disable()

# REPORT
CMD_COUNTER = {}
ENV_COUNTER = {}
def PrintFinalReport():
  """This function is run just before scons exits and dumps various reports.
  """
  # Note, these global declarations are not strictly necessary
  global pre_base_env
  global CMD_COUNTER
  global ENV_COUNTER

  if pre_base_env.Bit('target_stats'):
    print
    print '*' * 70
    print 'COMMAND EXECUTION REPORT'
    print '*' * 70
    for k in sorted(CMD_COUNTER.keys()):
      print "%4d %s" % (CMD_COUNTER[k], k)

    print
    print '*' * 70
    print 'ENVIRONMENT USAGE REPORT'
    print '*' * 70
    for k in sorted(ENV_COUNTER.keys()):
      print "%4d  %s" % (ENV_COUNTER[k], k)

  failures = []
  for failure in GetBuildFailures():
    for node in Flatten(failure.node):
      failures.append({
          # If this wasn't a test, "GetTestName" will return raw_name.
          'test_name': GetTestName(node),
          'raw_name': str(node.path),
          'errstr': failure.errstr
      })

  json_path = ARGUMENTS.get('json_build_results_output_file')
  if json_path:
    with open(json_path, 'w') as f:
      json.dump(failures, f, sort_keys=True, indent=2)

  if not failures:
    return

  print
  print '*' * 70
  print 'ERROR REPORT: %d failures' % len(failures)
  print '*' * 70
  print
  for failure in failures:
    test_name = failure['test_name']
    if test_name != failure['raw_name']:
      test_name = '%s (%s)' % (test_name, failure['raw_name'])
    print "%s failed: %s\n" % (test_name, failure['errstr'])


def VerboseConfigInfo(env):
  "Should we print verbose config information useful for bug reports"
  if '--help' in sys.argv: return False
  if env.Bit('prebuilt') or env.Bit('built_elsewhere'): return False
  return env.Bit('sysinfo')


# SANITY CHECKS

# NOTE BitFromArgument(...) implicitly defines additional ACCEPTABLE_ARGUMENTS.
ACCEPTABLE_ARGUMENTS = set([
    # TODO: add comments what these mean
    # TODO: check which ones are obsolete
    ####  ASCII SORTED ####
    # Use a destination directory other than the default "scons-out".
    'DESTINATION_ROOT',
    'MODE',
    'SILENT',
    # Limit bandwidth of browser tester
    'browser_tester_bw',
    # Location to download Chromium binaries to and/or read them from.
    'chrome_binaries_dir',
    # used for chrome_browser_tests: path to the browser
    'chrome_browser_path',
    # A comma-separated list of test names to disable by excluding the
    # tests from a test suite.  For example, 'small_tests
    # disable_tests=run_hello_world_test' will run small_tests without
    # including hello_world_test.  Note that if a test listed here
    # does not exist you will not get an error or a warning.
    'disable_tests',
    # used for chrome_browser_tests: path to a pre-built browser plugin.
    'force_ppapi_plugin',
    # force emulator use by tests
    'force_emulator',
    # force sel_ldr use by tests
    'force_sel_ldr',
    # force nacl_helper_bootstrap used by tests
    'force_bootstrap',
    # force irt image used by tests
    'force_irt',
    # generate_ninja=FILE enables a Ninja backend for SCons.  This writes a
    # .ninja build file to FILE describing all of SCons' build targets.
    'generate_ninja',
    # Path to a JSON file for machine-readable output.
    'json_build_results_output_file',
    # Replacement memcheck command for overriding the DEPS-in memcheck
    # script.  May have commas to separate separate shell args.  There
    # is no quoting, so this implies that this mechanism will fail if
    # the args actually need to have commas.  See
    # http://code.google.com/p/nativeclient/issues/detail?id=3158 for
    # the discussion of why this argument is needed.
    'memcheck_command',
    # If the replacement memcheck command only works for trusted code,
    # set memcheck_trusted_only to non-zero.
    'memcheck_trusted_only',
    # When building with MSan, this can be set to values 0 (fastest, least
    # useful reports) through 2 (slowest, most useful reports). Default is 1.
    'msan_track_origins',
    # colon-separated list of linker flags, e.g. "-lfoo:-Wl,-u,bar".
    'nacl_linkflags',
    # prefix to add in-front of perf tracking trace labels.
    'perf_prefix',
    # colon-separated list of pnacl bcld flags, e.g. "-lfoo:-Wl,-u,bar".
    # Not using nacl_linkflags since that gets clobbered in some tests.
    'pnacl_bcldflags',
    'platform',
    # Run tests under this tool (e.g. valgrind, tsan, strace, etc).
    # If the tool has options, pass them after comma: 'tool,--opt1,--opt2'.
    # NB: no way to use tools the names or the args of
    # which contains a comma.
    'run_under',
    # More args for the tool.
    'run_under_extra_args',
    # Multiply timeout values by this number.
    'scale_timeout',
    # test_wrapper specifies a wrapper program such as
    # tools/run_test_via_ssh.py, which runs tests on a remote host
    # using rsync and SSH.  Example usage:
    #   ./scons run_hello_world_test platform=arm force_emulator= \
    #     test_wrapper="./tools/run_test_via_ssh.py --host=armbox --subdir=tmp"
    'test_wrapper',
    # Replacement tsan command for overriding the DEPS-in tsan
    # script.  May have commas to separate separate shell args.  There
    # is no quoting, so this implies that this mechanism will fail if
    # the args actually need to have commas.  See
    # http://code.google.com/p/nativeclient/issues/detail?id=3158 for
    # the discussion of why this argument is needed.
    'tsan_command',
    # Run browser tests under this tool. See
    # tools/browser_tester/browsertester/browserlauncher.py for tool names.
    'browser_test_tool',
    # Where to install header files for public consumption.
    'includedir',
    # Where to install libraries for public consumption.
    'libdir',
    # Where to install trusted-code binaries for public (SDK) consumption.
    'bindir',
    # Where a Breakpad build output directory is for optional Breakpad testing.
    'breakpad_tools_dir',
    # Allows overriding of the nacl newlib toolchain directory.
    'nacl_newlib_dir',
    # Allows override of the nacl glibc toolchain directory.
    'nacl_glibc_dir',
    # Allows override of the pnacl newlib toolchain directory.
    'pnacl_newlib_dir',
    # Allows overriding the version number in the toolchain's
    # FEATURE_VERSION file.  This is used for PNaCl ABI compatibility
    # testing.
    'toolchain_feature_version',
  ])


# Overly general to provide compatibility with existing build bots, etc.
# In the future it might be worth restricting the values that are accepted.
_TRUE_STRINGS = set(['1', 'true', 'yes'])
_FALSE_STRINGS = set(['0', 'false', 'no'])


# Converts a string representing a Boolean value, of some sort, into an actual
# Boolean value. Python's built in type coercion does not work because
# bool('False') == True
def StringValueToBoolean(value):
  # ExpandArguments may stick non-string values in ARGUMENTS. Be accommodating.
  if isinstance(value, bool):
    return value

  if not isinstance(value, basestring):
    raise Exception("Expecting a string but got a %s" % repr(type(value)))

  if value.lower() in _TRUE_STRINGS:
    return True
  elif value.lower() in _FALSE_STRINGS:
    return False
  else:
    raise Exception("Cannot convert '%s' to a Boolean value" % value)


def GetBinaryArgumentValue(arg_name, default):
  if not isinstance(default, bool):
    raise Exception("Default value for '%s' must be a Boolean" % arg_name)
  if arg_name not in ARGUMENTS:
    return default
  return StringValueToBoolean(ARGUMENTS[arg_name])


# name is the name of the bit
# arg_name is the name of the command-line argument, if it differs from the bit
def BitFromArgument(env, name, default, desc, arg_name=None):
  # In most cases the bit name matches the argument name
  if arg_name is None:
    arg_name = name

  DeclareBit(name, desc)
  assert arg_name not in ACCEPTABLE_ARGUMENTS, repr(arg_name)
  ACCEPTABLE_ARGUMENTS.add(arg_name)

  if GetBinaryArgumentValue(arg_name, default):
    env.SetBits(name)
  else:
    env.ClearBits(name)


# SetUpArgumentBits declares binary command-line arguments and converts them to
# bits. For example, one of the existing declarations would result in the
# argument "bitcode=1" causing env.Bit('bitcode') to evaluate to true.
# NOTE Command-line arguments are a SCons-ism that is separate from
# command-line options.  Options are prefixed by "-" or "--" whereas arguments
# are not.  The function SetBitFromOption can be used for options.
# NOTE This function must be called before the bits are used
# NOTE This function must be called after all modifications of ARGUMENTS have
# been performed. See: ExpandArguments
def SetUpArgumentBits(env):
  BitFromArgument(env, 'bitcode', default=False,
    desc='We are building bitcode')

  BitFromArgument(env, 'pnacl_native_clang_driver', default=False,
    desc='Use the (experimental) native PNaCl Clang driver')

  BitFromArgument(env, 'nacl_clang', default=(not env.Bit('bitcode') and
                                              not env.Bit('nacl_glibc')),
    desc='Use the native nacl-clang newlib compiler instead of nacl-gcc')

  BitFromArgument(env, 'translate_fast', default=False,
    desc='When using pnacl TC (bitcode=1) use accelerated translation step')

  BitFromArgument(env, 'use_sz', default=False,
    desc='When using pnacl TC (bitcode=1) use Subzero for fast translation')

  BitFromArgument(env, 'built_elsewhere', default=False,
    desc='The programs have already been built by another system')

  BitFromArgument(env, 'skip_trusted_tests', default=False,
    desc='Only run untrusted tests - useful for translator testing'
      ' (also skips tests of the IRT itself')

  BitFromArgument(env, 'nacl_pic', default=False,
    desc='generate position indepent code for (P)NaCl modules')

  BitFromArgument(env, 'nacl_static_link', default=not env.Bit('nacl_glibc'),
    desc='Whether to use static linking instead of dynamic linking '
      'for building NaCl executables during tests. '
      'For nacl-newlib, the default is 1 (static linking). '
      'For nacl-glibc, the default is 0 (dynamic linking).')

  BitFromArgument(env, 'nacl_disable_shared', default=not env.Bit('nacl_glibc'),
    desc='Do not build shared versions of libraries. '
      'For nacl-newlib, the default is 1 (static libraries only). '
      'For nacl-glibc, the default is 0 (both static and shared libraries).')

  # Defaults on when --verbose is specified.
  # --verbose sets 'brief_comstr' to False, so this looks a little strange
  BitFromArgument(env, 'target_stats', default=not GetOption('brief_comstr'),
    desc='Collect and display information about which commands are executed '
      'during the build process')

  BitFromArgument(env, 'werror', default=True,
    desc='Treat warnings as errors (-Werror)')

  BitFromArgument(env, 'disable_nosys_linker_warnings', default=False,
    desc='Disable warning mechanism in src/untrusted/nosys/warning.h')

  BitFromArgument(env, 'naclsdk_validate', default=True,
    desc='Verify the presence of the SDK')

  # TODO(mseaborn): Remove this, since this is always False -- Valgrind is
  # no longer supported.  This will require removing some Chromium-side
  # references.
  BitFromArgument(env, 'running_on_valgrind', default=False,

=== oxide/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/build/cmake)

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()

include(ProjectInit)
oxide_project_init()

include(CheckCXXCompilerFlag)
include(GNUInstallDirs)

include(ChromiumBuildShim)
include(CommonProperties)
include(LibFilenameUtils)
include(Options)

# Define variables used throughout the build
set(OXIDE_OUTPUT_DIR ${CMAKE_BINARY_DIR}/out)
set(OXIDE_BIN_OUTPUT_DIR ${OXIDE_OUTPUT_DIR}/bin)
set(OXIDE_LIB_OUTPUT_DIR ${OXIDE_OUTPUT_DIR}/lib)
set(OXIDE_PACKAGE_STAGE_DIR ${CMAKE_BINARY_DIR}/_package_stage)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  # Use gold everywhere
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=gold")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=gold")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=gold")
endif()

# Required for out-of-tree builds
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
# We have a script for loading apps from the tree
set(CMAKE_SKIP_BUILD_RPATH TRUE)
include_directories(${OXIDE_SOURCE_DIR})

set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# Allow the version number to be used in the build
string(REGEX REPLACE "([^\\.]+)\\.([^\\.]+)\\.([^\\.]+)" "\\1" PROJECT_VERSION_MAJOR ${PROJECT_VERSION})
string(REGEX REPLACE "([^\\.]+)\\.([^\\.]+)\\.([^\\.]+)" "\\2" PROJECT_VERSION_MINOR ${PROJECT_VERSION})
string(REGEX REPLACE "([^\\.]+)\\.([^\\.]+)\\.([^\\.]+)" "\\3" PROJECT_VERSION_PATCH ${PROJECT_VERSION})

add_definitions(-DOXIDE_GETTEXT_DOMAIN="${GETTEXT_PACKAGE}")

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  add_definitions(-DOS_LINUX)
else()
  message(FATAL_ERROR "Unsupported CMAKE_SYSTEM_NAME")
endif()

# Check we have a new enough compiler
if(CMAKE_COMPILER_ID STREQUAL "GNU" AND
   CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
  message(FATAL_ERROR "Oxide requires at least GCC 4.8 to build")
endif()
CHECK_CXX_COMPILER_FLAG("-std=c++11" _COMPILER_HAS_CXX11_RESULT)
if(NOT _COMPILER_HAS_CXX11_RESULT)
  message(FATAL_ERROR "Oxide requires a compiler that supports -std=c++11")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

# Import the configuration for this build
include(${OXIDE_SOURCE_DIR}/${OXIDE_PLATFORM}/config.cmake)

# Set extra variables that depend on the configuration
get_library_filename(OXIDE_LIB_FILENAME ${OXIDE_LIB} ${OXIDE_LIB_VERSION})
get_library_namelink_filename(OXIDE_LIB_FILENAME_DEV ${OXIDE_LIB})

if(ENABLE_COMPONENT_BUILD)
  link_directories(${CHROMIUM_LIB_DIR})
endif()

if(ENABLE_TESTS)
  if(ENABLE_CHROMIUM_TESTS)
    add_test(NAME base_unittests
             COMMAND ${CHROMIUM_PRODUCT_DIR}/base_unittests)
    add_test(NAME crypto_unittests
             COMMAND ${CHROMIUM_PRODUCT_DIR}/crypto_unittests)
    add_test(NAME ipc_tests
             COMMAND ${CHROMIUM_PRODUCT_DIR}/ipc_tests)
  endif()
  add_test(NAME shared_unittests
           COMMAND ${CHROMIUM_PRODUCT_DIR}/oxide_shared_unittests)
endif()

add_chromium_build_all_target(build_all)

# Copy chrome_sandbox to chrome-sandbox
add_custom_target(
    copy_chrome_sandbox ALL
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      ${CHROMIUM_PRODUCT_DIR}/chrome_sandbox ${CHROMIUM_PRODUCT_DIR}/chrome-sandbox
    DEPENDS build_all)

# Allow objects linked by cmake to declare a run-time dependency on the
# main library, built with gn / ninja
add_library(${OXIDE_LIB} SHARED IMPORTED)
add_dependencies(${OXIDE_LIB} build_all)
set_target_properties(
    ${OXIDE_LIB} PROPERTIES
    IMPORTED_LOCATION ${CHROMIUM_LIB_DIR}/${OXIDE_LIB_FILENAME})

file(GLOB_RECURSE I18N_SRC_FILES
     RELATIVE ${CMAKE_SOURCE_DIR}
     ${OXIDE_PLATFORM}/**.cc shared/**.cc)
list(SORT I18N_SRC_FILES)

set(_OXIDE_INSTALL_LIB ${CHROMIUM_LIB_DIR}/${OXIDE_LIB_FILENAME})
set(_OXIDE_INSTALL_FILES
    ${CHROMIUM_PRODUCT_DIR}/oxide.pak
    ${CHROMIUM_PRODUCT_DIR}/oxide_100_percent.pak
    ${CHROMIUM_PRODUCT_DIR}/oxide_200_percent.pak
    ${CHROMIUM_PRODUCT_DIR}/icudtl.dat
    ${CHROMIUM_LIB_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}ffmpeg${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CHROMIUM_PRODUCT_DIR}/natives_blob.bin
    ${CHROMIUM_PRODUCT_DIR}/snapshot_blob.bin)
set(_OXIDE_INSTALL_PROGRAMS ${CHROMIUM_PRODUCT_DIR}/${OXIDE_RENDERER})
set(_CHROME_SANDBOX ${CHROMIUM_PRODUCT_DIR}/chrome-sandbox)
set(_OXIDE_INSTALL_LOCALEDIR ${CHROMIUM_PRODUCT_DIR}/chromium_l10n)

install(FILES ${_OXIDE_INSTALL_LIB} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink
        ${OXIDE_LIB_FILENAME} ${OXIDE_LIB_FILENAME_DEV}
        WORKING_DIRECTORY \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})")
install(FILES ${_OXIDE_INSTALL_FILES} DESTINATION ${OXIDE_INSTALL_LIBEXECDIR})
install(PROGRAMS ${_OXIDE_INSTALL_PROGRAMS}
        DESTINATION ${OXIDE_INSTALL_LIBEXECDIR})
install(PROGRAMS ${_CHROME_SANDBOX}
        DESTINATION ${OXIDE_INSTALL_LIBEXECDIR}
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE
                    GROUP_READ WORLD_EXECUTE WORLD_READ SETUID)
install(DIRECTORY ${_OXIDE_INSTALL_LOCALEDIR}
        DESTINATION ${OXIDE_INSTALL_LIBEXECDIR})
set(_COMPONENT_BUILD_INSTALL_EXCLUDES
    "buildtools;chromium_l10n;gen;host_;Mojo Applications;obj;pyproto;resources;ui")
file(RELATIVE_PATH _COMPONENT_LIB_REL ${CHROMIUM_PRODUCT_DIR} ${CHROMIUM_LIB_DIR})
if(ENABLE_COMPONENT_BUILD)
  set(_COMPONENT_BUILD_INSTALL_PARAMS
      DIRECTORY ${CHROMIUM_LIB_DIR}/
      DESTINATION ${OXIDE_INSTALL_LIBEXECDIR}/${_COMPONENT_LIB_REL}
      FILES_MATCHING PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
  foreach(e ${_COMPONENT_BUILD_INSTALL_EXCLUDES})
    list(APPEND _COMPONENT_BUILD_INSTALL_PARAMS PATTERN "${e}" EXCLUDE)
  endforeach()
  install(${_COMPONENT_BUILD_INSTALL_PARAMS})
endif()

add_subdirectory(po)
add_subdirectory(${OXIDE_PLATFORM})

add_custom_target(
    test-package-common-libs
    COMMAND ${CMAKE_COMMAND} -DFILES=${_OXIDE_INSTALL_LIB}
    -DTYPE=FILE -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}
    -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
add_custom_target(
    test-package-common-programs
    COMMAND ${CMAKE_COMMAND}
    "-DFILES=\"${_OXIDE_INSTALL_PROGRAMS};${_CHROME_SANDBOX}\""
    -DTYPE=PROGRAM
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
    -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
add_custom_target(
    test-package-common-files
    COMMAND ${CMAKE_COMMAND} "-DFILES=\"${_OXIDE_INSTALL_FILES}\""
    -DTYPE=FILE
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
    -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
add_custom_target(
    test-package-common-locales
    COMMAND ${CMAKE_COMMAND} -DFILES=${_OXIDE_INSTALL_LOCALEDIR}
    -DTYPE=DIRECTORY
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
    -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
if(ENABLE_COMPONENT_BUILD)
  add_custom_target(
      test-package-common-component-libs
      COMMAND ${CMAKE_COMMAND} -DFILES=${CHROMIUM_LIB_DIR}/
      -DMATCH_PATTERN="*${CMAKE_SHARED_LIBRARY_SUFFIX}" -DTYPE=DIRECTORY
      -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}/${_COMPONENT_LIB_REL}
      "-DEXCLUDES=\"${_COMPONENT_BUILD_INSTALL_EXCLUDES}\""
      -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
endif()

add_custom_target(
    test-package-common
    DEPENDS test-package-common-libs
            test-package-common-programs
            test-package-common-files
            test-package-common-locales)
if(ENABLE_COMPONENT_BUILD)
  add_dependencies(test-package-common test-package-common-component-libs)
endif()

add_custom_target(
    test-package
    COMMAND ${CMAKE_COMMAND} -E
    tar czvf ${OXIDE_OUTPUT_DIR}/${OXIDE_PLATFORM_FULLNAME}.tar.gz *
    WORKING_DIRECTORY ${OXIDE_PACKAGE_STAGE_DIR}
    DEPENDS test-package-common test-package-${OXIDE_PLATFORM})

run_generate_ninja()

=== oxide/po/CMakeLists.txt ===
include(FindGettext)
include(GNUInstallDirs)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${GETTEXT_PACKAGE})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

add_custom_target(${POT_FILE}
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          --from-code=UTF-8
                          --add-comments=TRANSLATORS
                          --c++ --qt --keyword=dgettext:2
                          --package-name=${DOMAIN}
                          --copyright-holder='Canonical Ltd.'
                          ${I18N_SRC_FILES})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== oxide/qt/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2015 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include(PackageConfigHelper)

set(OXIDE_MOCK_QTPLUGIN_DIR ${CMAKE_CURRENT_BINARY_DIR}/tests/mock/plugins)
set(OXIDE_QMLPLUGIN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/out/imports)

set(OXIDE_QUICKLIB OxideQtQuick)

find_package(Qt5Core 5.2.0 REQUIRED)
find_package(Qt5Gui 5.2.0 REQUIRED)
find_package(Qt5Qml 5.2.0 REQUIRED)
# 5.2.0 is required for us to be able to set a share context
find_package(Qt5Quick 5.2.0 REQUIRED)
if(ENABLE_TESTS)
  find_package(Qt5Feedback REQUIRED)
  find_package(Qt5Positioning REQUIRED)
  find_package(Qt5Test REQUIRED)
  find_package(Qt5QuickTest REQUIRED)
  find_package(Qt5PlatformSupport REQUIRED)
endif()

if(NOT CMAKE_CROSSCOMPILING)
  # qmake isn't multi-arch aware as it installs arch-specific mkspec files
  # in to /usr/share, so we can't use it here (we'd need a qmake binary
  # for the host arch using data for the target arch)
  find_program(QMAKE_EXECUTABLE qmake)
  if(QMAKE_EXECUTABLE STREQUAL "QMAKE_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "qmake not found")
  endif()
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/run_qmlapp.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/run_qmlapp.sh
    IMMEDIATE @ONLY)
file(INSTALL ${CMAKE_CURRENT_BINARY_DIR}/run_qmlapp.sh
     DESTINATION ${OXIDE_BIN_OUTPUT_DIR}
     FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
         GROUP_READ GROUP_EXECUTE
         WORLD_READ WORLD_EXECUTE)

configure_and_install_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/core/api/OxideQtCoreConfig.cmake.in)

# See https://launchpad.net/1578808 - QOpenGLFunctions methods in builds
#  that define QT_OPENGL_ES_2 use GLESv2 symbols inline
set(CMAKE_REQUIRED_INCLUDES ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${Qt5Gui_LIBRARIES})
check_cxx_source_compiles(
    "#include <QOpenGLFunctions>
    #ifndef QT_OPENGL_ES_2
    # error
    #endif
    int main(int argc, char** argv) { return 0; }
    " QTGUI_OPENGL_REQUIRES_GL_LINKING)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/core/api/
        DESTINATION ${OXIDE_INSTALL_INCLUDEDIR}/OxideQtCore
        FILES_MATCHING PATTERN *.h
        PATTERN *_p.h EXCLUDE
        PATTERN includes* EXCLUDE)

set_target_properties(
    ${OXIDE_LIB} PROPERTIES
    INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR}/core/api/includes
    INTERFACE_LINK_LIBRARIES Qt5::Core)

set(OXIDE_QT_PACKAGE_QMLPLUGIN_DIR qml)

add_subdirectory(qmlplugin)
add_subdirectory(quick)

if(ENABLE_UITK_WEBVIEW)
  add_subdirectory(uitk)
endif()

if(ENABLE_OXIDEQMLSCENE)
  if(NOT ${Qt5Quick_VERSION_STRING} VERSION_LESS "5.4.0")
    message(FATAL_ERROR
            "oxideqmlscene is not supported on Qt 5.4.0 and later - you can "
            "use qmlscene instead")
  elseif(NOT ${Qt5Quick_VERSION_STRING} VERSION_LESS "5.3.0")
    message(WARNING
            "oxideqmlscene is redundant on Qt 5.3.0 and later - you can use "
            "qmlscene instead")
  endif()
  add_subdirectory(qmlrunner)
endif()

if(ENABLE_DOCUMENTATION)
  add_subdirectory(documentation)
endif()

if(ENABLE_TESTS)
  add_test(NAME qt_unittests
           COMMAND ${CHROMIUM_PRODUCT_DIR}/oxide_qt_unittests)
  add_test(NAME qt_screen_unittests
           COMMAND ${CHROMIUM_PRODUCT_DIR}/oxide_qt_screen_unittests --qt-plugin-path=${OXIDE_MOCK_QTPLUGIN_DIR} -platform mock_qpa --single-process-tests)
  add_subdirectory(tests)
endif()

add_custom_target(
    test-package-qt-runner
    COMMAND ${CMAKE_COMMAND}
    -DSRCFILE=${CMAKE_CURRENT_SOURCE_DIR}/run_qmlapp.sh.in
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}
    -DQML_DIR=${OXIDE_QT_PACKAGE_QMLPLUGIN_DIR}
    -DPRODUCT_DIR=${OXIDE_PLATFORM_FULLNAME} -DOXIDE_RENDERER=${OXIDE_RENDERER}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/build/scripts/make-test-package-qmlrunner.cmake)

add_custom_target(
    test-package-qt
    DEPENDS test-package-qt-quick test-package-qt-qmlplugin test-package-qt-runner)
if(ENABLE_UITK_WEBVIEW)
  add_dependencies(test-package-qt test-package-uitk-lib test-package-uitk-qmlplugin)
endif()

=== sdch/open-vcdiff/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

project (open-vcdiff CXX C)
set (VERSION 0.8.4)
# For config.h.in to avoid generic define
set (OPEN_VCDIFF_VERSION ${VERSION})
set (PROJECT_SOVERSION 0)


# Configuration options
option(vcdiff_build_tests "Build all of vcdiff tests." ON)
option(vcdiff_build_exec "Build vcdiff exectuable" ON)
option(vcdiff_use_system_gflags "Use system wide installed gflags" OFF)
option(vcdiff_use_system_gtest "Use system wide installed gtest" OFF)

# Add subprojects first so we won't interfere with config.h.in

if (vcdiff_build_exec)
  set (GFLAGS_BUILD_gflags_LIB OFF)
  set (GFLAGS_BUILD_gflags_nothreads_LIB ON)
  set (GFLAGS_INSTALL_HEADERS OFF)
  set (GFLAGS_INSTALL_SHARED_LIBS OFF)
  set (GFLAGS_INSTALL_STATIC_LIBS OFF)
  if (${vcdiff_use_system_gflags})
    find_library(gflags gflags)
  else()
    add_subdirectory (third_party/gflags)
  endif()
endif ()

include (CheckIncludeFiles)
check_include_files (ext/rope HAVE_EXT_ROPE)
check_include_files (getopt.h HAVE_GETOPT_H)
check_include_files (malloc.h HAVE_MALLOC_H)
check_include_files (sys/mman.h HAVE_SYS_MMAN_H)
check_include_files (sys/time.h HAVE_SYS_TIME_H)
check_include_files (unistd.h HAVE_UNISTD_H)
check_include_files (windows.h HAVE_WINDOWS_H)

include (CheckFunctionExists)
check_function_exists (gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists (memalign HAVE_MEMALIGN)
check_function_exists (posix_memalign HAVE_POSIX_MEMALIGN)
check_function_exists (mprotect HAVE_MPROTECT)

configure_file (${PROJECT_SOURCE_DIR}/src/config.h.in ${PROJECT_BINARY_DIR}/config.h)
include_directories ("${PROJECT_BINARY_DIR}")

include_directories (${PROJECT_SOURCE_DIR}/src)
include_directories (${PROJECT_SOURCE_DIR}/src/zlib)

set (VCDCOM_SRC
  "src/google/format_extension_flags.h"
  "src/google/output_string.h"
  "src/addrcache.h"
  "src/checksum.h"
  "src/codetable.h"
  "src/logging.h"
  "src/unique_ptr.h"
  "src/varint_bigendian.h"
  "src/vcdiff_defs.h"
  "src/zlib/zlib.h"
  "src/zlib/zconf.h"
  "src/zlib/adler32.c"
  "src/addrcache.cc"
  "src/codetable.cc"
  "src/logging.cc"
  "src/varint_bigendian.cc"
)
add_library (vcdcom "" ${VCDCOM_SRC})
if (BUILD_SHARED_LIBS)
  add_library (vcdcom_shared "SHARED" ${VCDCOM_SRC})
  set_target_properties (vcdcom_shared PROPERTIES
    OUTPUT_NAME vcdcom
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_SOVERSION})
endif ()

set (VCDDEC_SRC
  "src/decodetable.cc"
  "src/headerparser.cc"
  "src/vcdecoder.cc"
)
add_library (vcddec "" ${VCDDEC_SRC})
target_link_libraries (vcddec vcdcom)
if (BUILD_SHARED_LIBS)
  add_library (vcddec_shared "SHARED" ${VCDDEC_SRC})
  set_target_properties (vcddec_shared PROPERTIES
    OUTPUT_NAME vcddec
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_SOVERSION})
  target_link_libraries (vcddec_shared vcdcom_shared)
endif ()

set (VCDENC_SRC
  "src/blockhash.cc"
  "src/encodetable.cc"
  "src/instruction_map.cc"
  "src/jsonwriter.cc"
  "src/vcdiffengine.cc"
  "src/vcencoder.cc"
)
add_library (vcdenc "" ${VCDENC_SRC})
target_link_libraries (vcdenc vcdcom)
if (BUILD_SHARED_LIBS)
  add_library (vcdenc_shared "SHARED" ${VCDENC_SRC})
  set_target_properties (vcdenc_shared PROPERTIES
    OUTPUT_NAME vcdenc
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_SOVERSION})
  target_link_libraries (vcdenc_shared vcdcom_shared)
endif ()

install (DIRECTORY src/google DESTINATION include)
install (TARGETS vcdcom vcdenc vcddec DESTINATION lib)
if (BUILD_SHARED_LIBS)
  install (TARGETS vcdcom_shared vcdenc_shared vcddec_shared DESTINATION lib)
endif ()

if (vcdiff_build_exec)
  add_executable (vcdiff "src/vcdiff_main.cc")
  target_link_libraries (vcdiff vcddec vcdenc gflags)
  install (TARGETS vcdiff DESTINATION bin)
endif ()

if (vcdiff_build_tests)
  enable_testing ()
  if (${vcdiff_use_system_gtest})
    find_package (GTest)
    if (${GTEST_FOUND})
      set (gtest_main ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBARY})
      include_directories(${GTEST_INCLUDE_DIRS})
    else()
      # On Debian it doens't install libgtest.a. Instead it provides sources in
      # /usr/src/gtest
      add_subdirectory (/usr/src/gtest gtest)
    endif()
  else()
    set (gtest_install OFF CACHE BOOL "Don't install gtest" FORCE)
    add_subdirectory (third_party/googletest/googletest)
  endif()

  add_library (vcdecoder_test_common
    "src/vcdecoder_test.cc"
  )
  target_link_libraries (vcdecoder_test_common vcddec gtest_main)


  add_executable (addrcache_test src/addrcache_test.cc)
  target_link_libraries (addrcache_test vcdcom gtest_main)
  add_test (addrcache_test addrcache_test)

  add_executable (blockhash_test src/blockhash_test.cc)
  target_link_libraries (blockhash_test vcdenc gtest_main)
  add_test (blockhash_test blockhash_test)

  add_executable (codetable_test src/codetable_test.cc)
  target_link_libraries (codetable_test vcdcom gtest_main)
  add_test (codetable_test codetable_test)

  add_executable (decodetable_test src/decodetable_test.cc)
  target_link_libraries (decodetable_test vcddec vcdcom gtest_main)
  add_test (decodetable_test decodetable_test)

  add_executable (encodetable_test src/encodetable_test.cc)
  target_link_libraries (encodetable_test vcdenc vcdcom gtest_main)
  add_test (encodetable_test encodetable_test)

  add_executable (headerparser_test src/headerparser_test.cc)
  target_link_libraries (headerparser_test vcddec vcdcom gtest_main)
  add_test (headerparser_test headerparser_test)

  add_executable (instruction_map_test src/instruction_map_test.cc)
  target_link_libraries (instruction_map_test vcdenc vcdcom gtest_main)
  add_test (instruction_map_test instruction_map_test)

  add_executable (output_string_test src/output_string_test.cc)
  target_link_libraries (output_string_test gtest_main)
  add_test (output_string_test output_string_test)

  add_executable (rolling_hash_test src/rolling_hash_test.cc)
  target_link_libraries (rolling_hash_test vcdcom gtest_main)
  add_test (rolling_hash_test rolling_hash_test)

  add_executable (varint_bigendian_test src/varint_bigendian_test.cc)
  target_link_libraries (varint_bigendian_test vcdcom gtest_main)
  add_test (varint_bigendian_test varint_bigendian_test)

  add_executable (vcdecoder1_test src/vcdecoder1_test.cc)
  target_link_libraries (vcdecoder1_test vcdecoder_test_common)
  add_test (vcdecoder1_test vcdecoder1_test)

  add_executable (vcdecoder2_test src/vcdecoder2_test.cc)
  target_link_libraries (vcdecoder2_test vcdecoder_test_common)
  add_test (vcdecoder2_test vcdecoder2_test)

  add_executable (vcdecoder3_test src/vcdecoder3_test.cc)
  target_link_libraries (vcdecoder3_test vcdecoder_test_common)
  add_test (vcdecoder3_test vcdecoder3_test)

  add_executable (vcdecoder4_test src/vcdecoder4_test.cc)
  target_link_libraries (vcdecoder4_test vcdecoder_test_common)
  add_test (vcdecoder4_test vcdecoder4_test)

  add_executable (vcdecoder5_test src/vcdecoder5_test.cc)
  target_link_libraries (vcdecoder5_test vcdecoder_test_common)
  add_test (vcdecoder5_test vcdecoder5_test)

  add_executable (vcdiffengine_test src/vcdiffengine_test.cc)
  target_link_libraries (vcdiffengine_test vcdenc vcdcom gtest_main)
  add_test (vcdiffengine_test vcdiffengine_test)

  add_executable (vcencoder_test src/vcencoder_test.cc)
  target_link_libraries (vcencoder_test vcddec vcdenc vcdcom gtest_main)
  add_test (vcencoder_test vcencoder_test)

  add_executable (jsonwriter_test src/jsonwriter_test.cc)
  target_link_libraries (jsonwriter_test vcdenc vcdcom gtest_main)
  add_test (jsonwriter_test jsonwriter_test)

  if (${UNIX})
    add_test (
      NAME vcdiff_test
      COMMAND ${PROJECT_SOURCE_DIR}/src/vcdiff_test.sh ${PROJECT_SOURCE_DIR})
  elseif (${WINDOWS})
    add_test (
      NAME vcdiff_test
      COMMAND ${PROJECT_SOURCE_DIR}/src/vcdiff_test.bat vcdiff)
  endif()

endif ()  # vcdiff_build_tests

=== oxide/qt/documentation/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

find_program(QDOC_EXE qdoc)
if(QDOC_EXE STREQUAL "QDOC_EXE-NOTFOUND")
  message(FATAL "Cannot find qdoc executable")
endif()

# CMake doesn't seem to provide a way to get at QT_INSTALL_DOCS
if(NOT CMAKE_CROSSCOMPILING)
  execute_process(COMMAND ${QMAKE_EXECUTABLE} -qt5 -query QT_INSTALL_DOCS
                  RESULT_VARIABLE _RESULT
                  OUTPUT_VARIABLE QT_INSTALL_DOCS
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT _RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to determine QT_INSTALL_DOCS from qmake")
  endif()
else()
  set(QT_INSTALL_DOCS "/usr/share/qt5/doc")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oxideqt.qdocconf.in
               ${CMAKE_CURRENT_BINARY_DIR}/oxideqt.qdocconf
               IMMEDIATE @ONLY)

add_custom_target(doc 
                  COMMAND ${QDOC_EXE} -qt5 ${CMAKE_CURRENT_BINARY_DIR}/oxideqt.qdocconf
                  COMMENT "Building the documentation")

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/${OXIDE_PLATFORM_FULLNAME}
        OPTIONAL)

=== oxide/qt/qmlplugin/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2015 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(OXIDE_QMLPLUGIN qmloxideplugin)
set(OXIDE_QMLPLUGIN_MODULE_NAME com/canonical/Oxide)

set(OXIDE_QMLPLUGIN_SRCS oxide_qml_plugin.cc)

if(${Qt5Qml_VERSION_STRING} VERSION_LESS "5.5.0")
  list(APPEND OXIDE_QMLPLUGIN_SRCS
       oxide_qml_download_request.cc
       oxide_qml_load_event.cc
       oxide_qml_navigation_item.cc
       oxide_qml_ssl_certificate.cc
       oxide_qml_value_type_provider.cc)
  set(LEGACY_QMLVALUE_TYPES TRUE)
endif()

# CMake doesn't seem to provide a way to get at QT_INSTALL_QML
if(NOT CMAKE_CROSSCOMPILING)
  execute_process(COMMAND ${QMAKE_EXECUTABLE} -qt5 -query QT_INSTALL_QML
                  RESULT_VARIABLE _RESULT
                  OUTPUT_VARIABLE QT_INSTALL_QML
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT _RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to determine QT_INSTALL_QML from qmake")
  endif()
else()
  set(QT_INSTALL_QML "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml")
endif()

add_library(${OXIDE_QMLPLUGIN} MODULE ${OXIDE_QMLPLUGIN_SRCS})
target_link_libraries(
    ${OXIDE_QMLPLUGIN}
    ${Qt5Core_LIBRARIES}
    ${Qt5Qml_LIBRARIES}
    ${Qt5Quick_LIBRARIES}
    ${OXIDE_LIB}
    ${OXIDE_QUICKLIB})
set_target_properties(
    ${OXIDE_QMLPLUGIN} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${OXIDE_QMLPLUGIN_OUTPUT_DIR}/${OXIDE_QMLPLUGIN_MODULE_NAME}
    AUTOMOC TRUE)
target_compile_options(${OXIDE_QMLPLUGIN} PRIVATE -fno-rtti)
target_include_directories(
    ${OXIDE_QMLPLUGIN} PRIVATE
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_PRIVATE_INCLUDE_DIRS})
if(DEFINED LEGACY_QMLVALUE_TYPES)
  target_compile_definitions(
      ${OXIDE_QMLPLUGIN} PRIVATE -DLEGACY_QMLVALUE_TYPES)
endif()

add_custom_target(
    copy_${OXIDE_QMLPLUGIN}_qmldir ALL
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      ${CMAKE_CURRENT_SOURCE_DIR}/qmldir
      ${OXIDE_QMLPLUGIN_OUTPUT_DIR}/${OXIDE_QMLPLUGIN_MODULE_NAME})

install(FILES ${OXIDE_QMLPLUGIN_OUTPUT_DIR}/${OXIDE_QMLPLUGIN_MODULE_NAME}/qmldir
        DESTINATION ${QT_INSTALL_QML}/${OXIDE_QMLPLUGIN_MODULE_NAME})
install(TARGETS ${OXIDE_QMLPLUGIN}
        DESTINATION ${QT_INSTALL_QML}/${OXIDE_QMLPLUGIN_MODULE_NAME})

add_custom_target(
    test-package-qt-qmlplugin
    COMMAND ${CMAKE_COMMAND}
    "-DFILES=\"$<TARGET_FILE:${OXIDE_QMLPLUGIN}>;${OXIDE_QMLPLUGIN_OUTPUT_DIR}/${OXIDE_QMLPLUGIN_MODULE_NAME}/qmldir\""
    -DTYPE=FILE
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_QT_PACKAGE_QMLPLUGIN_DIR}/${OXIDE_QMLPLUGIN_MODULE_NAME}
    -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)

# Only generate typeinfo if not cross compiling
if(NOT CMAKE_CROSSCOMPILING)
  add_custom_target(generate_oxide_qmltypes ALL
    COMMAND env "LD_LIBRARY_PATH=${CHROMIUM_OUTPUT_DIR}/Release/lib:${OXIDE_LIB_OUTPUT_DIR}"
            env "QML2_IMPORT_PATH=${OXIDE_QMLPLUGIN_OUTPUT_DIR}"
            qmlplugindump -v -noinstantiate com.canonical.Oxide ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR} ${OXIDE_QMLPLUGIN_MODULE_NAME} > ${CMAKE_CURRENT_BINARY_DIR}/oxide.qmltypes
            && cp ${CMAKE_CURRENT_BINARY_DIR}/oxide.qmltypes ${CMAKE_CURRENT_SOURCE_DIR}/
            || true
    WORKING_DIRECTORY ${OXIDE_QMLPLUGIN_OUTPUT_DIR}
  )
  add_dependencies(generate_oxide_qmltypes ${OXIDE_QMLPLUGIN})

endif()

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/oxide.qmltypes
        DESTINATION ${QT_INSTALL_QML}/${OXIDE_QMLPLUGIN_MODULE_NAME})

=== oxide/qt/qmlrunner/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2015 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(OXIDE_QMLRUNNER oxideqmlscene)

set(OXIDE_QMLRUNNER_SRCS main.cc)

add_executable(${OXIDE_QMLRUNNER} ${OXIDE_QMLRUNNER_SRCS})
target_link_libraries(
    ${OXIDE_QMLRUNNER} 
    ${Qt5Core_LIBRARIES}
    ${Qt5Gui_LIBRARIES}
    ${Qt5Qml_LIBRARIES}
    ${Qt5Quick_LIBRARIES})
target_include_directories(
    ${OXIDE_QMLRUNNER} PRIVATE
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS})
set_target_properties(
    ${OXIDE_QMLRUNNER} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${OXIDE_BIN_OUTPUT_DIR})

install(TARGETS ${OXIDE_QMLRUNNER}
        DESTINATION ${CMAKE_INSTALL_BINDIR})

=== oxide/qt/quick/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

qt5_wrap_cpp(MOC_EXTRA
             api/oxideqquickwebcontextdelegateworker_p_p.h)

set(OXIDE_QUICKLIB_SRCS
    api/oxideqquickcookiemanager.cc
    api/oxideqquickglobal.cc
    api/oxideqquicklocationbarcontroller.cc
    api/oxideqquicknavigationhistory.cc
    api/oxideqquicknavigationitem.cc
    api/oxideqquickscriptmessage.cc
    api/oxideqquickscriptmessagehandler.cc
    api/oxideqquickscriptmessagerequest.cc
    api/oxideqquicktouchselectioncontroller.cc
    api/oxideqquickuserscript.cc
    api/oxideqquickwebcontext.cc
    api/oxideqquickwebcontextdelegateworker.cc
    api/oxideqquickwebframe.cc
    api/oxideqquickwebview.cc
    api/oxidequseragentoverriderequest.cc
    contents_view.cc
    legacy_contents_view.cc
    oxide_qquick_accelerated_frame_node.cc
    oxide_qquick_file_picker.cc
    oxide_qquick_image_frame_node.cc
    oxide_qquick_init.cc
    oxide_qquick_software_frame_node.cc
    oxide_qquick_touch_handle_drawable.cc
    qquick_legacy_alert_dialog.cc
    qquick_legacy_auxiliary_ui_factory.cc
    qquick_legacy_before_unload_dialog.cc
    qquick_legacy_confirm_dialog.cc
    qquick_legacy_javascript_dialog.cc
    qquick_legacy_prompt_dialog.cc
    qquick_legacy_web_context_menu.cc
    qquick_legacy_web_popup_menu.cc
    ${MOC_EXTRA})

add_library(${OXIDE_QUICKLIB} SHARED ${OXIDE_QUICKLIB_SRCS})
target_compile_definitions(
    ${OXIDE_QUICKLIB} PRIVATE -DOXIDE_QTQUICK_IMPLEMENTATION)
target_include_directories(
    ${OXIDE_QUICKLIB} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/api/includes)
target_include_directories(
    ${OXIDE_QUICKLIB} PRIVATE
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS})
target_link_libraries(
    ${OXIDE_QUICKLIB}
    PUBLIC  ${OXIDE_LIB} ${Qt5Core_LIBRARIES} ${Qt5Qml_LIBRARIES} ${Qt5Quick_LIBRARIES}
    PRIVATE ${Qt5Gui_LIBRARIES})
if(QTGUI_OPENGL_REQUIRES_GL_LINKING)
  target_link_libraries(${OXIDE_QUICKLIB} PRIVATE ${Qt5Gui_OPENGL_LIBRARIES})
endif()
set_target_properties(
    ${OXIDE_QUICKLIB} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${OXIDE_LIB_OUTPUT_DIR}
    AUTOMOC TRUE
    SOVERSION ${OXIDE_LIB_VERSION})

install(TARGETS ${OXIDE_QUICKLIB} DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/api/
        DESTINATION ${OXIDE_INSTALL_INCLUDEDIR}/OxideQtQuick
        FILES_MATCHING PATTERN *.h
        PATTERN *_p.h EXCLUDE
        PATTERN includes* EXCLUDE)

add_custom_target(
    test-package-qt-quick
    COMMAND ${CMAKE_COMMAND} -DFILES=$<TARGET_FILE:${OXIDE_QUICKLIB}>
    -DTYPE=FILE -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}
    -P ${OXIDE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)

get_library_filename(OXIDE_QUICKLIB_FILENAME ${OXIDE_QUICKLIB} ${OXIDE_LIB_VERSION})
configure_and_install_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/OxideQtQuickConfig.cmake.in)

=== oxide/qt/tests/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

add_subdirectory(mock)
add_subdirectory(unit)
add_subdirectory(qmltests)

=== oxide/qt/uitk/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(OXIDE_UITKLIB OxideUbuntuUITK)

add_subdirectory(lib)
add_subdirectory(qmlplugin)

=== debian/changelog ===
oxide-qt (1.21.5-0ubuntu1) zesty; urgency=medium

  * Update to v1.21.5 (see USN-3236-1)
    - Bump Chromium rev to 57.0.2987.110
    - Build everything with the correct symbol visibility (-fvisibility=hidden)
    - Revert "Decide focus state of webview based on activeFocusItem check of
      window", as it caused a regression in popup menu handling (LP: #1649577)
    - Unbreak build for older CMake versions
    - Unbreak ENABLE_PLUGINS=0 build
    - Fix LP: #1654363 - Fails to build with vivid gcc
    - Fix LP: #1654512 - Unbreak component build
    - Fix LP: #1649577 - Decide the webview focus state from ItemChanged event
      not the focusIn/Out events
    - Fix LP: #1637194 - Add <select> popup menu implementation to UbuntuWebView
    - Fix LP: #1656303 - Test hang at the start of tst_focus.qml
    - Fix LP: #1649861 - Session save/restore across oxide versions
    - Test that we don't leak context menus or popup menus when a webview
      closes
    - tst_WebViewPopupMenu.qml should verify that the menu is visible
    - Fix CMake error on cross-compilation after installing qtsystems5-dev
    - Make WebContextMenu and WebPopupMenu ownership more obvious
    - Fix LP: #1647799 - Don't run ubuntu-api and ubuntu-ui test sequences
      when built without ENABLE_UITK_WEBVIEW
    - Fix LP: #1568296, LP: #1656905 - Change the behaviour of JS dialogs.
      + Alert dialogs requested from background webviews are no longer
        displayed immediately, but are delayed until the webview is brought to
        the foreground. In this case, window.alert() returns and script
        execution continues immediately.
      + Confirm and prompt dialogs from background webviews are suppressed.
      + Dialogs are automatically dismissed if another webview is brought to
        the foreground.
      + Before Unload dialogs will only be displayed if they are associated
        with a navigation that is application initiated or triggered from a
        user gesture. Otherwise, the navigation will proceed without a prompt.
    - Remove the openerName parameter from WebContextMenuDesktop.qml
    - Fix a case where the JavaScriptDialog implementation could leak
    - Fix LP: #1637195 - Add JS dialog implementation to UbuntuWebView
    - Emit warnings when trying to provide dialog components with UbuntuWebView
    - Use AuxiliaryUIFactory for legacy UI components, and add a "Legacy"
      prefix to those classes
    - Rename qt::Web{Context,Popup}MenuImpl to qt::Web{Context,Popup}MenuHost
      for consistency with JavaScriptDialogHost
    - Fix LP: #1665978 - Sync ParamTraits for content::WebPreferences to make
      double-tap-to-zoom work again
    - Fix LP: #1668614 - Fix build failure with GCC 4.8 due to lack of
      stdatomic.h

  * Refresh gross-hack-for-dual-ffmpeg-build.patch
  * Drop debian/patches/lp1642317.patch - fixed upstream

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 17 Mar 2017 21:30:31 +0000

oxide-qt (1.20.4-0ubuntu1) zesty; urgency=medium

  * Update to v1.20.4 (see USN-3180-1)
    - Bump Chromium rev to 56.0.2924.87
    - Fix LP: #1642318 - Build failure on arm64
    - Fix LP: #1649861 - session save/restore across oxide versions
    - Fix LP: #1632490 - Disable zoom-for-dsf
    - Fix LP: #1632487 - Update tst_WebView_findController.qml to test that
      results are updated on navigation
    - Fix LP: #1610929 - Implement Screen::GetShellMode()
    - Fix LP: #1637184 - Add libOxideUbuntuUITK, associated QML plugin and
      UbuntuWebView implementation, which will eventually replace the
      Ubuntu.Web component
    - Stop using Q_DECL_EXPORT in various places
    - Enable use_external_popup_menu and remove our hack for supporting these
    - Refactor WebContextMenu
    - Documentation changes - ensure that the PermissionRequest classe
      indicate the inheritance chain and add missing entries for a few signals
    - Remove WebView::GetDisplay, as it's unused
    - Pass context menu params to the webview via a separate object
    - Fix a compiler warning
    - Fix a build failure with ENABLE_HYBRIS_CAMERA
    - Fix a build failure with ENABLE_COMPONENT_BUILD
    - Fix media hub build
    - Fix LP: #1637186 - Add context menu implementation to UbuntuWebView
    - Disable enable_media_routing as it results in a lot of console spam now
    - Fix LP: #1639241 - Set the solid colour scrollbar colour correctly
    - Fix LP: #1643428 - Fix an issue where the fling direction sometimes
      reverses
    - Fix a build failure with ENABLE_HYBRIS_CAMERA
    - Fix LP: #1643548 - Emit a warning when importing Oxide.Ubuntu
    - Fix LP: #1642381 - Don't spin up a zygote process in single process mode
    - Remove OXIDE_DISABLE_SETUID_SANDBOX environment variable - it doesn't
      work anyway
    - Ensure that the value returned from TestApi.getBoundingClientRectForSelector
      is scaled correctly
    - Fix LP: #1637187 - Add QML tests for context menu
    - Fix LP: #1637190 - Add API to allow embedders to customize actions in
      the context menu
    - Fix LP: #1640634 - "Open {link,media} in new {tab,window}" entries in
      context menu shouldn't cause WebView.navigationRequested to fire

  * Refresh gross-hack-for-dual-ffmpeg-build.patch
  * Fix LP: #1642317 - misaligned access when running mksnapshot during the
    armhf build. Add this as a distro-patch to avoid having to fork the v8
    repo for upstream checkouts. This isn't a problem for cross-builds anyway
    - Add debian/patches/lp1642317.patch
    - Update debian/patches/series
  * Add experimental Ubuntu UITK library and QML plugin packages. Note that
    this API is not stable yet and is likely to undergo breaking changes in
    future releases
    - update debian/control
    - update debian/rules
    - update debian/liboxideqt-qmlplugin.install
    - add debian/liboxideubuntuuitk0.install
    - add debian/qml-module-oxide-ubuntu.install



=== debian/control ===
Source: oxide-qt
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.0.0),
    cmake,
    qt5-qmake,
    qtchooser,
    qtbase5-dev,
    qtbase5-dev-tools,
    qtdeclarative5-dev,
    qtbase5-private-dev,
    qtdeclarative5-private-dev,
    qtpositioning5-dev,
    qtfeedback5-dev,
    qttools5-dev-tools,
    ninja-build,
    python,
    pkg-config,
    libglib2.0-dev,
    libnss3-dev,
    libpci-dev,
    libgcrypt11-dev,
    libdbus-1-dev,
    libudev-dev,
    libpulse-dev,
    libasound2-dev,
    libx11-dev,
    libxi-dev,
    libcap-dev,
    libdrm-dev,
    libfontconfig1-dev,
    libfreetype6-dev,
    libpango1.0-dev,
    libxext-dev,
    libxcomposite-dev,
    libxrender-dev,
    libkrb5-dev,
    libssl-dev,
    libgdk-pixbuf2.0-dev,
    libnotify-dev,
    gperf,
    bison,
    xvfb,
    qtdeclarative5-qtquick2-plugin,
    qtdeclarative5-test-plugin,
    libexif-dev,
    libxcursor-dev,
    libxrandr-dev,
    libxtst-dev,
#    libmedia-hub-dev [armhf],
    libandroid-properties-dev,
    libhybris-dev,
    python-psutil,
    libffi-dev,
    qtbase5-doc-html,
    qtdeclarative5-doc-html
Standards-Version: 3.9.5
Homepage: https://launchpad.net/oxide

Package: liboxideqtcore0
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends},
    ${misc:Depends},
    oxideqt-codecs (= ${binary:Version}) | oxideqt-codecs-extra (= ${binary:Version})
Description: Web browser engine for Qt (core library and components)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the core library, sandbox, renderer and support
 files required to run applications with Oxide

Package: liboxideqtcore-dev
Architecture: amd64 i386 armhf arm64
Section: libdevel
Depends: ${shlibs:Depends},
    ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version})
Description: Web browser engine for Qt (development files for core library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the development files required to compile programs
 against the Oxide core library

Package: liboxideqtquick0
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    oxideqt-codecs (= ${binary:Version}) | oxideqt-codecs-extra (= ${binary:Version})
Description: Web browser engine for Qt (QtQuick library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the QtQuick library required to run QML applications
 with Oxide

Package: liboxideqtquick-dev
Architecture: amd64 i386 armhf arm64
Section: libdevel
Depends: ${shlibs:Depends},
    ${misc:Depends},
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (development files for QtQuick library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the development files required to compile programs
 against the Oxide QtQuick library

Package: liboxideqt-qmlplugin
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (QML plugin)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the QML plugin required to run QML applications with
 Oxide

Package: liboxideubuntuuitk0
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (Ubuntu UITK library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the Ubuntu UITK library required to embed a WebView in
 Ubuntu QML applications

Package: qml-module-oxide-ubuntu
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtquick0 (= ${binary:Version}),
    liboxideubuntuuitk0 (= ${binary:Version})
Description: Web browser engine for Qt (Ubuntu UITK QML plugin)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the Ubuntu UITK QML plugin required to embed a WebView
 in Ubuntu QML applications

Package: oxideqt-codecs
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: oxideqt-codecs-extra
Breaks: liboxideqtcore0 (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs-extra, liboxideqtcore0 (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides some media codecs needed for the HTML5 <audio> and
 <video> tags. Included are the free Theora, Vorbis, Opus, VP8 and VP9
 codecs

Package: oxideqt-codecs-extra
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: oxideqt-codecs
Breaks: liboxideqtcore0 (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs, liboxideqtcore0 (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides some media codecs needed for the HTML5 <audio> and
 <video> tags. Included are the Theora, Vorbis, Opus, VP8, VP9, MP3, AAC
 and H.264 codecs

Package: oxideqt-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides documentation that is useful for application developers.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_MULTIARCH 	:= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH		:= $(shell dpkg-architecture -qDEB_HOST_ARCH)
COMMON_OPTIONS := -DENABLE_TESTS=1 -DENABLE_HYBRIS_CAMERA=1 -DBOOTSTRAP_GN=1 -DENABLE_UITK_WEBVIEW=1

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_OPTIONS) -DENABLE_PROPRIETARY_CODECS=1

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- doc

override_dh_auto_test:
	#xvfb-run -a -s "-screen 0 1024x768x24" dh_auto_test --max-parallel=1

override_dh_auto_install:
	dh_auto_install
	dh_auto_configure -- $(COMMON_OPTIONS) -DENABLE_PROPRIETARY_CODECS=0
	dh_auto_build
	dh_auto_install --destdir debian/tmp.free

override_dh_install:
	dh_install
	dh_install -poxideqt-codecs --sourcedir=debian/tmp.free usr/lib/$(DEB_HOST_MULTIARCH)/oxide-qt/libffmpeg.so

override_dh_fixperms:
	dh_fixperms
	chmod 4755 debian/liboxideqtcore0/usr/lib/*/oxide-qt/chrome-sandbox
